无源汇上下界可行流(多校7)

来源:互联网 发布:常州罗盘网络智能科技 编辑:程序博客网 时间:2024/05/29 19:04

http://acm.hdu.edu.cn/showproblem.php?pid=4940

Destroy Transportation system

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 298    Accepted Submission(s): 184


Problem Description
Tom is a commander, his task is destroying his enemy’s transportation system.

Let’s represent his enemy’s transportation system as a simple directed graph G with n nodes and m edges. Each node is a city and each directed edge is a directed road. Each edge from node u to node v is associated with two values D and B, D is the cost to destroy/remove such edge, B is the cost to build an undirected edge between u and v.

His enemy can deliver supplies from city u to city v if and only if there is a directed path from u to v. At first they can deliver supplies from any city to any other cities. So the graph is a strongly-connected graph.

He will choose a non-empty proper subset of cities, let’s denote this set as S. Let’s denote the complement set of S as T. He will command his soldiers to destroy all the edges (u, v) that u belongs to set S and v belongs to set T.

To destroy an edge, he must pay the related cost D. The total cost he will pay is X. You can use this formula to calculate X:

After that, all the edges from S to T are destroyed. In order to deliver huge number of supplies from S to T, his enemy will change all the remained directed edges (u, v) that u belongs to set T and v belongs to set S into undirected edges. (Surely, those edges exist because the original graph is strongly-connected)

To change an edge, they must remove the original directed edge at first, whose cost is D, then they have to build a new undirected edge, whose cost is B. The total cost they will pay is Y. You can use this formula to calculate Y:

At last, if Y>=X, Tom will achieve his goal. But Tom is so lazy that he is unwilling to take a cup of time to choose a set S to make Y>=X, he hope to choose set S randomly! So he asks you if there is a set S, such that Y<X. If such set exists, he will feel unhappy, because he must choose set S carefully, otherwise he will become very happy.
 

Input
There are multiply test cases.

The first line contains an integer T(T<=200), indicates the number of cases.

For each test case, the first line has two numbers n and m.

Next m lines describe each edge. Each line has four numbers u, v, D, B.
(2=<n<=200, 2=<m<=5000, 1=<u, v<=n, 0=<D, B<=100000)

The meaning of all characters are described above. It is guaranteed that the input graph is strongly-connected.
 

Output
For each case, output "Case #X: " first, X is the case number starting from 1.If such set doesn’t exist, print “happy”, else print “unhappy”.
 

Sample Input
23 31 2 2 22 3 2 23 1 2 23 31 2 10 22 3 2 23 1 2 2
 

Sample Output
Case #1: happyCase #2: unhappy
Hint
In first sample, for any set S, X=2, Y=4. In second sample. S= {1}, T= {2, 3}, X=10, Y=4.

题意:给出一个有向强连通图,每条边有两个值分别是破坏该边的代价和把该边建成无向边的代价(建立无向边的前提是删除该边)问是否存在一个集合S,和一个集合的补集T,破坏所有S集合到T集合的边代价和是X,然后修复T到S的边为无向边代价和是Y,满足Y<X;满足输出unhappy,否则输出happy;

分析:首先可以把每条边的权值做一下变换,即破坏有向边的权值A=d,和建立无向边的权值B=b+d;

官方题解:




程序:

#include"string.h"#include"stdio.h"#include"iostream"#include"queue"#define inf 100000000#include"math.h"#define M 333#define eps 1e-5using namespace std;struct node{    int u,v,w,c,next;}edge[40009];int t,head[M],dis[M],work[M];void init(){    t=0;    memset(head,-1,sizeof(head));}void add(int u,int v,int w,int c){    edge[t].u=u;    edge[t].v=v;    edge[t].w=w;    edge[t].c=c;    edge[t].next=head[u];    head[u]=t++;    edge[t].u=v;    edge[t].v=u;    edge[t].w=0;    edge[t].c=c;    edge[t].next=head[v];    head[v]=t++;}int bfs(int start,int endl){    queue<int>q;    memset(dis,-1,sizeof(dis));    dis[start]=0;    q.push(start);    while(!q.empty())    {        int u=q.front();        q.pop();        for(int i=head[u];i!=-1;i=edge[i].next)        {            int v=edge[i].v;            if(edge[i].w&&dis[v]==-1)            {                dis[v]=dis[u]+1;                q.push(v);                if(v==endl)                    return 1;            }        }    }    return 0;}int dfs(int u,int a,int T){    if(u==T)        return a;    for(int &i=work[u];i!=-1;i=edge[i].next)    {        int v=edge[i].v;        if(edge[i].w&&dis[v]==dis[u]+1)        {            int tt=dfs(v,min(edge[i].w,a),T);            if(tt)            {                edge[i].w-=tt;                edge[i^1].w+=tt;                return tt;            }        }    }    return 0;}int Dinic(int S,int T){    int ans=0;    while(bfs(S,T))    {        memcpy(work,head,sizeof(head));        while(int tt=dfs(S,inf,T))            ans+=tt;    }    return ans;}int main(){    int T,kk=1;    cin>>T;    while(T--)    {        int n,m;        scanf("%d%d",&n,&m);        init();        int st=0;        int sd=n+1;        int sum=0;        while(m--)        {            int a,b,c,d;            scanf("%d%d%d%d",&a,&b,&c,&d);            sum+=c;            add(a,b,d,c+d);            add(a,sd,c,c);            add(st,b,c,c);        }        int ans=Dinic(st,sd);        printf("Case #%d: ",kk++);        if(sum!=ans)        {            printf("unhappy\n");        }        else            printf("happy\n");    }    return 0;}


0 0